local PLUGIN = {}

PLUGIN.Name = "Teleport" --Name to be displayed
PLUGIN.Author = "::Frosty" --Your steam nick name
PLUGIN.File = "teleport.lua" --filename of plugin like "kill.lua"
PLUGIN.Client = true --Run Client Side
PLUGIN.Server = true --Run Server Side
PLUGIN.CloseOnClick = true --Sets if the menu should close once a player is selected
PLUGIN.AllowSelf = true --Sets if LocalPlayer can perform action on self

PLUGIN.MenuFunction = "AllPlayers" --List Method, "AllPlayers" Lists everyone, "AllExceptLocal" Lists Everyone Except The LocalPlayer
PLUGIN.SubMenu = {"To Target", "To Them"} --{"Sub 1", "Sub 2"} Table of strings for a submenu, nil for none
PLUGIN.SubMenufunction = { --Only Runs On Server. { func1, func2 } Table of corresponding functions to the submenu, nil for none
				function( ply, caller )
					local trace = {} 
					trace.start = caller:GetShootPos()
					trace.endpos = caller:GetShootPos() + caller:GetAimVector() * 99999
					trace.filter = caller
					local tr = util.TraceLine( trace )
					
					local setpos = ( tr.HitPos - caller:GetAimVector( ) * 50 + Vector( 0, 0, 5 ) )
					local faceang = (caller:GetPos() - setpos):Angle()
					faceang = Angle( math.NormalizeAngle(faceang.p), math.NormalizeAngle(faceang.y), math.NormalizeAngle(faceang.r) )
					if util.IsInWorld( setpos ) then
						if ply == caller then
							ply:SetPos( tr.HitPos + Vector(0,0,5) )
							ply:SetLocalVelocity( Vector( 0, 0, 0 ) )
						else
							ply:SetPos( setpos )
							ply:SetEyeAngles( faceang )
							ply:SetLocalVelocity( Vector( 0, 0, 0 ) )
						end
					end
				end,
				function( ply, caller )
					function findbestpoint()
						local OffsetTests = {}
						OffsetTests[1] = Vector( 100, 0, 0 )
						OffsetTests[2] = Vector( 0, 100, 0 )
						OffsetTests[3] = Vector( 0, -100, 0 )
						OffsetTests[4] = Vector( -100, 0, 0 )
						OffsetTests[5] = Vector( 100, 100, 0 )
						OffsetTests[6] = Vector( -100, -100, 0 )
						local plyPos = ply:GetPos() + Vector( 0, 0, 5 )
						for i=1,6 do
							local worldtest = plyPos + OffsetTests[i]
							local trace = {} 
							trace.start = plyPos
							trace.endpos = worldtest
							trace.filter = ply
							local tr = util.TraceLine( trace )
					
							if !tr.Hit then
								return worldtest
							end
						end
					end
					
					local setpos = findbestpoint() or (ply:GetPos() + Vector(0,0,100))
					local faceang = (ply:GetPos() - setpos):Angle()
					faceang = Angle( math.NormalizeAngle(faceang.p), math.NormalizeAngle(faceang.y), math.NormalizeAngle(faceang.r) )
					
					caller:SetPos( setpos )
					caller:SetEyeAngles( faceang )
					caller:SetLocalVelocity( Vector( 0, 0, 0 ) )
				end,
			}
PLUGIN.RunFunction = function( ply, caller ) --Only Runs On Server. This is the function run when a user selects a player, ply = target, caller = admin
end

FSA_LoadPlugin(PLUGIN) --Call this to load the plugin