Msg("\n-----------------\n[FSA][CL] Loading\n-----------------\n")
include("fsa_shared.lua")

local FSA_MainMenu = nil
function FSA_OpenMainMenu( ply, cmd, args )
	if FSA_MainMenu then
		FSA_MainMenu:Remove()
		FSA_MainMenu = nil
	end
    FSA_MainMenu = vgui.Create( "fsaMainMenu" )
end
concommand.Add( "+fsa_menu", FSA_OpenMainMenu )
local function FSA_RemoveMainMenu( ply, cmd, args )
    FSA_MainMenu:Remove()
end
concommand.Add( "-fsa_menu", FSA_RemoveMainMenu )

local PLAYER = FindMetaTable("Player")
function PLAYER:IsOwner()
	return self:GetNetworkedInt("fsa_level", 5) == 0
end
function PLAYER:IsSuperAdmin()
	return self:GetNetworkedInt("fsa_level", 5) <= 1
end
function PLAYER:IsAdmin()
	return self:GetNetworkedInt("fsa_level", 5) <= 2
end