local PLUGIN = {}

PLUGIN.Name = "Respawn" --Name to be displayed
PLUGIN.Author = "::Frosty" --Your steam nick name
PLUGIN.File = "respawn.lua" --filename of plugin like "kill.lua"
PLUGIN.Client = true --Run Client Side
PLUGIN.Server = true --Run Server Side
PLUGIN.CloseOnClick = true --Sets if the menu should close once a player is selected
PLUGIN.AllowSelf = true --Sets if LocalPlayer can perform action on self

PLUGIN.MenuFunction = "AllPlayers" --List Method, "AllPlayers" Lists everyone, "AllExceptLocal" Lists Everyone Except The LocalPlayer
PLUGIN.SubMenu = {"At Spawn", "At Same Point"} --{"Sub 1", "Sub 2"} Table of strings for a submenu, nil for none
PLUGIN.SubMenufunction = { --Only Runs On Server. { func1, func2 } Table of corresponding functions to the submenu, nil for none
				function( ply, caller )
					ply:KillSilent()
					ply:Spawn()
				end,
				function( ply, caller )
					local setpos = ply:GetPos()
					local setang = ply:EyeAngles()
					ply:KillSilent()
					ply:Spawn()
					ply:SetPos(setpos)
					ply:SetEyeAngles(setang)
				end,
			}

PLUGIN.RunFunction = function( ply, caller )
end

FSA_LoadPlugin(PLUGIN) --Call this to load the plugin